package com.aurellem.capture.examples;

import java.io.File;
import java.io.IOException;

import com.aurellem.capture.Capture;
import com.aurellem.capture.IsoTimer;
import com.aurellem.capture.video.AbstractVideoRecorder;
import com.jme3.app.SimpleApplication;
import com.jme3.material.Material;
import com.jme3.math.ColorRGBA;
import com.jme3.math.Vector3f;
import com.jme3.scene.Geometry;
import com.jme3.scene.shape.Box;

/** Recording Video from an application suitable for upload to youtube.*/
public class AdvancedVideo extends SimpleApplication {

	/*File staticVideo = 
		new File("/home/r/bullshit.avi");
		*/
	File movingVideo = 
		new File("/home/r/tmp/bullshit2.flv");

	AbstractVideoRecorder movingRecorder ;
	
    public static void main(String[] args){
        AdvancedVideo app = new AdvancedVideo();
        app.start();
    }

    public void initVideo(){ 
    	this.setTimer(new IsoTimer(60));
    	/*try{
    		// set the timer to 30fps lock-step
    		this.setTimer(new IsoTimer(30)); 
    		
    		//ViewPort compositeViewPort = renderManager.createFinalView("composite", cam);
    		//compositeViewPort.attachScene(this.rootNode);
    		//compositeViewPort.attachScene(this.guiNode);
    		this.viewPort.setClearFlags(true, true, true);
    		this.viewPort.setBackgroundColor(ColorRGBA.Black);
    		movingRecorder = new AVIVideoRecorder(movingVideo); 
    		this.stateManager.attach(movingRecorder);
    		this.viewPort.addFinalProcessor(movingRecorder);
    		this.viewPort.attachScene(this.guiNode);
    		
    	}catch (IOException e) {
    		e.printStackTrace();}
    		*/
    	try {Capture.captureVideo(this, movingVideo);} 
    	catch (IOException e) {e.printStackTrace();}
		
    }
    protected Geometry player;
    
    public void simpleInitApp() {
    	initVideo(); // begin recording!
    	/** this blue box is our player character */
    	Box b = new Box(Vector3f.ZERO, 1, 1, 1);
    	player = new Geometry("blue cube", b);
    	Material mat = new Material(assetManager,
    		"Common/MatDefs/Misc/Unshaded.j3md");
    	mat.setColor("Color", ColorRGBA.Blue);
    	player.setMaterial(mat);
    	rootNode.attachChild(player);
    }

    /* Use the main event loop to trigger repeating actions. */
    public void simpleUpdate(float tpf) {
        // make the player rotate:
        player.rotate(0, 2*tpf, 0); 
    }
    
} 